/**
  Author: D.Gohsiroh
  source: http://meaw.kagechiyo.net/
  Licenses: GPL, The MIT License (MIT)
  Copyright: (c) 2014 D.Gohsiroh
  Version: 0.8
  Date: 26/01/2014
 **/
/**
 data/html
 にあるhtmlファイルを読み込んでindex.htmlを作成する関数
 クラスじゃないよ。
 単純に
 createIndexHtml();
 と呼び出せば、index.htmlが吐き出される
 **/
function createIndexHtml(){
  var xml = WScript.CreateObject("MSXML.DOMDocument");
  var body = loadSkeletonHTML(xml, getUserPath("resource\\index.skeleton.html")); // skeleton.htmlを利用する
  
  function loadAllHtmlInfomation(){
    var fso = getFSO();
    var folder = fso.GetFolder(getUserPath("html"));
    var fc = new Enumerator(folder.Files);
    var re = /.html$/;
    var re2 = /.htm$/;
    var excludes = ["icon.credit.html","sample.icon.html","index.html"];
    var result = new Array();
    for (; !fc.atEnd(); fc.moveNext()){
      var name = fc.item().Name;
      if (re.test(name) || re2.test(name)){
        var match = false;
        for (var i=0; i<excludes.length; i++){
          if (name == excludes[i]){
            match = true;
            break;
          }
        }
        if (match){
          continue;
        }
        var obj = new Object();
        obj.name=name;
        echo(name);
        var filespec = getUserPath("html\\"+name);
        
        var adTypeText = 2;
        var adReadLine = -2;
        
        var stream = new ActiveXObject("ADODB.Stream");
        stream.type = adTypeText;
        stream.charset = "UTF-8";
        stream.open();
        stream.loadFromFile(filespec);
        var reg = /<title>.+<\/title>/i;
        var reg2 = /\"shortcut icon\" .+\/>/i; //"
        var line;
        var title = null;
        var img = null;
        do{
          line = stream.readText(adReadLine);
          if (reg.test(line)){
            var p = reg.exec(line);
            if (p.length > 0){
              title = p[0].replace(/<title>/i,"").replace(/<\/title>/i,"");
              echo(title);
            }
            obj.title=title;
          }
          if (reg2.test(line)){
            var p = reg2.exec(line);
            if (p.length > 0){
              img = p[0].replace(/\"shortcut icon\" /i,"").replace(/\/>/i,"").replace(/\"/gi,"").replace(/href=/i,"").trim(); //"
              echo(img);
            }
            obj.img=img;
          }
        } while((title == null || img == null) && line.indexOf("</head>") == -1 && !stream.EOS);
        stream.close();
        result.push(obj);
      }
    }
    return result;
  }
  var infos = loadAllHtmlInfomation();
  for (var i=0; i<infos.length; i++){
    var A = xml.createElement("a");
    A.setAttribute("href", infos[i].name);
    var img = xml.createElement("img");
    A.appendChild(img);
    img.setAttribute("src", infos[i].img);
    var span = xml.createElement("span");
    A.appendChild(span);
    span.text=infos[i].title;
    body.appendChild(A);
    var span = xml.createElement("span");
    span.setAttribute("class", "noicon");
    span.text="   ";
    body.appendChild(span);
  }
  var htmltext = xml.xml;
  var explanation = LoadText(getUserPath("resource\\explanation.txt"));
  htmltext = htmltext.replace("$explanation",explanation);
  SaveText(getUserPath("html\\index.html"), htmltext);
}
